! write input data files : inputmatr, inpurhs
! with inputmatr determined by random subroutine,
! instead inputrhs is the sum of the columns of the inputmatr
PROGRAM CREATEFILE

 IMPLICIT NONE
 INTEGER :: NRWBLK, NBLOKS, I, J, K, Q, NPROCS
 REAL(KIND(1.0d0)), ALLOCATABLE :: STRUCTA(:,:,:), VECTB(:,:)
 
!    PRINT *,'Insert the size of each block '
!    READ  *, NRWBLK
     NRWBLK= 16

!    PRINT *,'Insert the number of block rows '
!    READ  *, NBLOKS
     NBLOKS=1024

    ALLOCATE ( STRUCTA(NRWBLK,NRWBLK,2*(NBLOKS+1)), &
               VECTB(NRWBLK,NBLOKS+1) )

    OPEN(UNIT=15,FILE='INPUTMATR',STATUS='REPLACE',FORM='FORMATTED')
    OPEN(UNIT=25,FILE='INPUTRHS',STATUS='REPLACE',FORM='FORMATTED')
!!structa will contains [S1 R1 S2 R2,..., Sm Rm, Ba Bb]
    DO K=1,2*(NBLOKS+1)
      DO J= 1,NRWBLK
        DO I=1,NRWBLK
          CALL RANDOM_NUMBER(STRUCTA(I,J,K))
          STRUCTA(I,J,K)=(STRUCTA(I,J,K)-0.5)*20
          WRITE(15,*) STRUCTA(I,J,K)
        ENDDO
      ENDDO
    ENDDO

!!VECTB will be the sum of columns of the babd matrix A
     DO I=1,NBLOKS
       VECTB(:,I+1)=SUM( STRUCTA(:,:,2*I-1), DIM=2 )+ &
                                 SUM( STRUCTA(:,:,2*I), DIM=2 )
     ENDDO
     VECTB(:,1)= SUM( STRUCTA(:,:,2*NBLOKS+1), DIM=2 )+ &
                     SUM( STRUCTA(:,:,2*NBLOKS+2), DIM=2 )
 



  DO I=1,NBLOKS+1
    DO J=1,NRWBLK
    !write in B and in file 'INPUTRHS'
     WRITE(25,*) VECTB(J,I)
    ENDDO
  ENDDO

  CLOSE(UNIT=15)
  CLOSE(UNIT=25)



END PROGRAM CREATEFILE
